Package org.apache.qpid.proton.engine

# Interface Event

All Superinterfaces:
  `Extendable`

public interface Event extends Extendable
Event

## Nested Class Summary

Nested Classes
Modifier and Type
Interface
Description
`static enum`
`Event.Type`
Event types built into the library.

## Method Summary

Modifier and Type
Method
Description
`Event`
`copy()`
`void`
`delegate()`
dispatch the event to all children of the handler.
`void`
`dispatch(Handler handler)`
`Connection`
`getConnection()`
`Object`
`getContext()`
`Delivery`
`getDelivery()`
`EventType`
`getEventType()`
`Link`
`getLink()`
`Reactor`
`getReactor()`
`Receiver`
`getReceiver()`
`Handler`
`getRootHandler()`
The `Handler` at the root of the handler tree.
`Selectable`
`getSelectable()`
`Sender`
`getSender()`
`Session`
`getSession()`
`Task`
`getTask()`
`Transport`
`getTransport()`
`Event.Type`
`getType()`
A concrete event type of core events.
`void`
`redispatch(EventType as_type, Handler handler)`
Synchronously redispatch the current event as a new `EventType` on the provided handler and it's children.

### Methods inherited from interface org.apache.qpid.proton.engine.Extendable

`attachments`

## Method Details

### getEventType

EventType getEventType()

Returns:
  type of the event. The event type can be defined outside of the proton library.

### getType

Event.Type getType()
A concrete event type of core events.

Returns:
  type of the event for core events. For events generated by extensions a `Event.Type.NON_CORE_EVENT` will be returned

### getContext

Object getContext()

### getRootHandler

Handler getRootHandler()
The `Handler` at the root of the handler tree.

Set by the `Reactor` before dispatching the event.

Returns:
  The root handler
See Also:
  - `redispatch(EventType, Handler)`

### dispatch

void dispatch(Handler handler) throws HandlerException

Throws:
  `HandlerException`

### redispatch

void redispatch(EventType as_type, Handler handler) throws HandlerException
Synchronously redispatch the current event as a new `EventType` on the provided handler and it's children.

Note: the `redispatch()` will complete before children of the current handler have had the current event dispatched, see `delegate()`.

Parameters:
  `as_type` - Type of event to dispatch
  `handler` - The handler where to start the dispatch. Use `getRootHandler()` to redispatch the new event to all handlers in the tree.
Throws:
  `HandlerException` - A wrapper exception of any unhandled exception thrown by `handler`

### delegate

void delegate() throws HandlerException
dispatch the event to all children of the handler. A handler can call this method explicitly to be able to do more processing after all child handlers have already processed the event. If handler does not invoke this method it is invoked implicitly by `dispatch(Handler)`

Throws:
  `HandlerException`

### getConnection

Connection getConnection()

### getSession

Session getSession()

### getLink

Link getLink()

### getSender

Sender getSender()

### getReceiver

Receiver getReceiver()

### getDelivery

Delivery getDelivery()

### getTransport

Transport getTransport()

### getReactor

Reactor getReactor()

### getSelectable

Selectable getSelectable()

### getTask

Task getTask()

### copy

Event copy()